
/****** Object:  StoredProcedure [dbo].[SP_ICS_GeneratePosting_InvoicePayment]    Script Date: 30/04/2021 17:06:14 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


-- =============================================
-- Author:		FID.Joko
-- Create date: 21-Sept-2013
-- Description:	Generate Invoice Inquiry ICS
-- Update	: FID.Ridwan : 19-Sep-2020
--			  => Change insert temporary table from dblink ICS to temp in IPPCS
--			  => add call sp --- (logic from ICS to IPPCS)
-- =============================================
ALTER PROCEDURE [dbo].[SP_ICS_GeneratePosting_InvoicePayment]
---DECLARE
	-- Add the parameters for the stored procedure here 
    @UserID VARCHAR(20) ,
    @SupplierInvoiceNo VARCHAR(MAX) ,
    @SupplierCode VARCHAR(MAX) ,
    @L_N_PROCESS_ID BIGINT
AS 

BEGIN
		-- SET NOCOUNT ON added to prevent extra result sets from
		-- interfering with SELECT statements.
    SET NOCOUNT ON;
        
	--DECLARE @UserID VARCHAR(20) = @i_UserID,
	--		@SupplierInvoiceNo VARCHAR(MAX) = @i_SupplierInvoiceNo,
	--		@SupplierCode VARCHAR(MAX) = @i_SupplierCode,
	--		@L_N_PROCESS_ID BIGINT = @i_L_N_PROCESS_ID

    DECLARE @PROC_ID VARCHAR(12) ,
        @PROCESS_ID BIGINT ,
        @LAST_PROCESS_ID VARCHAR(12) ,
        @TODAY VARCHAR(8) ,
        @NOW DATETIME ,
        @CURR_NO INT ,
        @CURR_PROCESS_ID VARCHAR(12) ,
        @SEQ_NO_LOG BIGINT ,
        @LOCATION VARCHAR(100) ,
        @PROC_STAT TINYINT ,
        @L_N_COUNT_MANIFEST INT ,
        @L_N_COUNT_ERR INT ,
        @ERR_FLAG BIT  
	
	DECLARE @st DATETIME = GETDATE()

    SET @LOCATION = 'SP ICS GeneratePosting Invoice Payment';
    SET @SEQ_NO_LOG = 1;
    SET @ERR_FLAG = 0; 
    SET @PROC_STAT = 0;
																	
    SET NOCOUNT ON	
         		
    BEGIN TRY
		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @L_N_PROCESS_ID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D
				WHERE PROCESS_ID = @L_N_PROCESS_ID
				)
			,'MPCS00002INF'
			,'INF'
			,'MPCS00002INF : Insert into temp invoice header'
			,@LOCATION
			,@UserID
			,GETDATE()	

		/* Remark FID.Ridwan 2020-09-19
		INSERT OPENQUERY (IPPCS_TO_ICS, 
		'SELECT  
			OTHER_PROCESS_ID,
			INV_NO,
			INV_POSTING_DT,
			INV_DT,
			SUPP_INVOICE_NO,
			SUPP_CD,
			PAYMENT_CURR,
			EXCHANGE_RATE,
			INV_AMT,
			ASSIGNMENT,
			HEADER_TEXT,
			INV_TEXT,
			BASELINE_DT,
			PAYMENT_TERM_CD,
			PAYMENT_METHOD_CD,
			PARTNER_BANK_KEY,
			CALC_TAX_FLAG,
			REVERSE_FLAG,
			TAX_CD,
			TAX_DT,
			TAX_AMT,
			INV_DESCRIPTION,
			LIV_BASED
		FROM 
		Tb_t_Invoice_h') */
		INSERT INTO TB_T_INVOICE_H (  
			PROCESS_ID,
			OTHER_PROCESS_ID,
			INV_NO,
			INV_POSTING_DT,
			INV_DT,
			SUPP_INVOICE_NO,
			SUPP_CD,
			PAYMENT_CURR,
			EXCHANGE_RATE,
			INV_AMT,
			ASSIGNMENT,
			HEADER_TEXT,
			INV_TEXT,
			BASELINE_DT,
			PAYMENT_TERM_CD,
			PAYMENT_METHOD_CD,
			PARTNER_BANK_KEY,
			CALC_TAX_FLAG,
			REVERSE_FLAG,
			TAX_CD,
			TAX_DT,
			TAX_AMT,
			INV_DESCRIPTION,
			LIV_BASED)
		select DISTINCT @L_N_PROCESS_ID, 
			   @L_N_PROCESS_ID, --1
			   RTRIM(ISNULL(INV_NO,'')),  --2
			   POSTING_DT,
			   INV_DT,
			   RTRIM(SUPP_INV_NO), --6
			   RTRIM(SUPP_CD), --7
			   RTRIM(PAY_CURR),  --8
			   1.00,--MAX(er.EXCHANGE_RATE),  --9
			   INV_AMT_TOTAL=MAX(INV_AMT_TOTAL),  --10
			   RTRIM(ASSIGNMENT),  --13
			   RTRIM(INV_TAX_NO),  --14
			   '' INV_TEXT,  --15
			   BASELINE_DT,  --16
			   RTRIM(PAY_TERM_CD),  --17
			   RTRIM(PAY_METHOD_CD), --18
			   SUPP_BANK_TYPE,
			   CALC_TAX_FLAG, --20
			   REVERSE_FLAG,  --21
			   RTRIM(TAX_CD),  --23
			   INV_TAX_DT, --24
			   MAX(INV_TAX_AMOUNT),
			   RTRIM(INV_TEXT) INV_DESCRIPTION,
			   '1'
		from TB_R_INV_UPLOAD tu
		--INNER JOIN TB_M_EXCHANGE_RATE er ON tu.PAY_CURR=er.CURRENCY_CD AND er.VALID_DT_FROM <= tu.POSTING_DT AND
		--								er.VALID_DT_TO >= tu.POSTING_DT AND er.FOREX_TYPE='A'
		WHERE LTRIM(SUPP_INV_NO)=LTRIM(@SupplierInvoiceNo) AND RTRIM(SUPP_CD)=@SupplierCode
		GROUP BY RTRIM(ISNULL(INV_NO,'')),  --2
		   POSTING_DT,
		   INV_DT,
		   RTRIM(SUPP_INV_NO), --6
		   RTRIM(SUPP_CD), --7
		   RTRIM(PAY_CURR),
		   RTRIM(ASSIGNMENT),  --13
		   RTRIM(INV_TAX_NO),  --14
		   RTRIM(INV_TEXT),  --15
		   BASELINE_DT,  --16
		   RTRIM(PAY_TERM_CD),  --17
		   RTRIM(PAY_METHOD_CD), --18
		   SUPP_BANK_TYPE,
		   CALC_TAX_FLAG, --20
		   REVERSE_FLAG,
		   RTRIM(TAX_CD),  --23
		   INV_TAX_DT

	SELECT  'TB_T_INV_H : ' + RTRIM(CAST(DATEDIFF(MILLISECOND, @st, GETDATE()) AS VARCHAR(MAX))) ' ms'
	SET @st = GETDATE()

	INSERT INTO TB_R_LOG_D (
		PROCESS_ID
		,SEQUENCE_NUMBER
		,MESSAGE_ID
		,MESSAGE_TYPE
		,[MESSAGE]
		,LOCATION
		,CREATED_BY
		,CREATED_DATE
		)
	SELECT @L_N_PROCESS_ID
		,(
			SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
			FROM dbo.TB_R_LOG_D
			WHERE PROCESS_ID = @L_N_PROCESS_ID
			)
		,'MPCS00002INF'
		,'INF'
		,'MPCS00002INF : Insert into temp invoice Detail'
		,@LOCATION
		,@UserID
		,GETDATE()	

	/* Remark FID.Ridwan 2020-09-19
	INSERT OPENQUERY (IPPCS_TO_ICS, 
		'SELECT  
			OTHER_PROCESS_ID,
			INV_NO,
			REFF_NO,
			INV_DOC_ITEM,
			PO_ITEM_NO,
			QUANTITY,
			PRICE_AMT,
			INV_AMT,
			TAX_CD,
			COMP_PRICE_CD,
			SUPP_INVOICE_NO,
			PO_NO,
			MAT_DOC_NO,
			MAT_DOC_ITEM,
			MAT_NO,
			ORI_MAT_NO,
			PROD_PURPOSE_CD,
			SOURCE_TYPE,
			PACKING_TYPE,
			PART_COLOR_SFX,
			DOC_DT,
			CONDITION_CATEGORY,
			CURR_CD,
			UNIT_OF_MEASURE_CD,
			PLANT_CD,
			SLOC_CD
		FROM 
		Tb_t_Invoice_d')*/
		INSERT INTO TB_T_INVOICE_D (  
			ROWNO,
			PROCESS_ID,
			OTHER_PROCESS_ID,
			INV_NO,
			REFF_NO,
			INV_DOC_ITEM,
			PO_ITEM_NO,
			QUANTITY,
			PRICE_AMT,
			INV_AMT,
			TAX_CD,
			COMP_PRICE_CD,
			SUPP_INVOICE_NO,
			PO_NO,
			MAT_DOC_NO,
			MAT_DOC_ITEM,
			MAT_NO,
			ORI_MAT_NO,
			PROD_PURPOSE_CD,
			SOURCE_TYPE,
			PACKING_TYPE,
			PART_COLOR_SFX,
			DOC_DT,
			CONDITION_CATEGORY,
			CURR_CD,
			UNIT_OF_MEASURE_CD,
			PLANT_CD,
			SLOC_CD)
		SELECT ROW_NUMBER() OVER(ORDER BY (SELECT 1)) ROWNO, TB.* 
		FROM (
		select DISTINCT @L_N_PROCESS_ID PROCESS_ID, 
			   @L_N_PROCESS_ID OTHER_PROCESS_ID, --1
			   RTRIM(ISNULL(INV_NO,'')) INV_NO,  --2
			   RTRIM(INV_REF_NO) INV_REF_NO, --3
			   RTRIM(INV_DOC_ITEM) INV_DOC_ITEM,
			   RTRIM(PO_ITEM_NO) PO_ITEM_NO,
			   QTY, --6
			   PRICE_AMT, --7
			   AMT,  --8
			   RTRIM(TAX_CD) TAX_CD,  --9
			   RTRIM(COMP_PRICE_CD) COMP_PRICE_CD,  --10
			   RTRIM(SUPP_INV_NO) SUPP_INV_NO,  --11
			   RTRIM(PO_NO) PO_NO,  --12
			   RTRIM(MAT_DOC_NO) MAT_DOC_NO,  --13
			   RTRIM(MAT_DOC_ITEM) MAT_DOC_ITEM,  --14
			   RTRIM(MAT_NO) MAT_NO,  --15
			   RTRIM(MAT_NO) ORI_MAT_NO,  --16
			   RTRIM(PROD_PURPOSE_CD) PROD_PURPOSE_CD,  --17
			   RTRIM(SOURCE_TYPE_CD) SOURCE_TYPE_CD,
			   RTRIM(PACKING_TYPE) PACKING_TYPE,
			   PART_COLOR_SFX, --18
			   DOC_DT,
			   RTRIM(CONDITION_CATEGORY) CONDITION_CATEGORY,
			   RTRIM(CURR_CD) CURR_CD,  --21
			   RTRIM(UOM_CD) UOM_CD,
			   RTRIM(PLANT_CD) PLANT_CD,
			   RTRIM(SLOC_CD) SLOC_CD
		from TB_R_INV_UPLOAD
		WHERE LTRIM(SUPP_INV_NO)=LTRIM(@SupplierInvoiceNo) AND RTRIM(SUPP_CD)=@SupplierCode) TB

	SELECT  'TB_T_INV_D : ' + RTRIM(CAST(DATEDIFF(MILLISECOND, @st, GETDATE()) AS VARCHAR(MAX))) ' ms'
	SET @st = GETDATE()
	--INSERT OPENQUERY (IPPCS_TO_ICS, 
	--	'SELECT  
	--		INV_NO,
	--		SUPP_INVOICE_NO,
	--		TAX_CD,
	--		TAX_AMT,
	--		ACCOUNT_KEY,
	--		LOCAL_TAX_AMT,
	--		PROCESS_ID
	--	FROM 
	--	Tb_t_Inv_Tax')
	--	select DISTINCT ISNULL(INV_NO,''),
	--		   RTRIM(SUPP_INV_NO),  --2
	--		   TAX_CD, --3
	--		   INV_TAX_AMOUNT,
	--		   'VST',
	--		   INV_AMT_LOCAL_CUR, --6
	--		   @L_N_PROCESS_ID --24
	--	from TB_R_INV_UPLOAD
	--	WHERE SUPP_INV_NO=@SupplierInvoiceNo
	
	IF EXISTS(SELECT '' FROM TB_T_INV_GL_ACCOUNT WHERE LTRIM(SUPP_INVOICE_NO)=LTRIM(@SupplierInvoiceNo) AND GL_ACCOUNT <> '')
	BEGIN
		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @L_N_PROCESS_ID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D
				WHERE PROCESS_ID = @L_N_PROCESS_ID
				)
			,'MPCS00002INF'
			,'INF'
			,'MPCS00002INF : Insert into temp invoice GL account'
			,@LOCATION
			,@UserID
			,GETDATE()	

		/* Remark FID.Ridwan 2020-09-19
		INSERT OPENQUERY (IPPCS_TO_ICS, 
			'SELECT  
				INV_NO,
				SUPP_INVOICE_NO,
				GL_ACCOUNT,
				INV_AMT,
				COST_CENTER,
				TAX_CD,
				OTHER_PROCESS_ID
			FROM 
			Tb_t_Inv_Gl_Account')*/
		INSERT INTO TB_T_INVOICE_GL_ACCOUNT(  
				INV_NO,
				SUPP_INVOICE_NO,
				GL_ACCOUNT,
				INV_AMT,
				COST_CENTER,
				TAX_CD,
				OTHER_PROCESS_ID,
				PROCESS_ID)
		select DISTINCT ISNULL(INV_NO,''),
			RTRIM(SUPP_INVOICE_NO),
			GL_ACCOUNT,
			INV_AMT,
			COST_CENTER,
			RTRIM(TAX_CD),
			@L_N_PROCESS_ID,
			@L_N_PROCESS_ID
		from TB_T_INV_GL_ACCOUNT
		WHERE LTRIM(SUPP_INVOICE_NO)=LTRIM(@SupplierInvoiceNo) AND GL_ACCOUNT <> ''

		SELECT  'TB_T_INV_GL_ACCOUNT : ' + RTRIM(CAST(DATEDIFF(MILLISECOND, @st, GETDATE()) AS VARCHAR(MAX))) ' ms'
		SET @st = GETDATE()
	END
		   
	INSERT INTO TB_R_LOG_D (
		PROCESS_ID
		,SEQUENCE_NUMBER
		,MESSAGE_ID
		,MESSAGE_TYPE
		,[MESSAGE]
		,LOCATION
		,CREATED_BY
		,CREATED_DATE
		)
	SELECT @L_N_PROCESS_ID
		,(
			SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
			FROM dbo.TB_R_LOG_D
			WHERE PROCESS_ID = @L_N_PROCESS_ID
			)
		,'MPCS00002INF'
		,'INF'
		,'MPCS00002INF : Insert into temp invoice witholding tax'
		,@LOCATION
		,@UserID
		,GETDATE()	

	/* Remark FID.Ridwan 2020-09-19   			
	INSERT OPENQUERY (IPPCS_TO_ICS, 
		'SELECT  
			INV_NO,
			SUPP_INVOICE_NO,
			WITHOLDING_TAX_CD,
			WITHOLDING_TAX_BASE_AMT,
			WITHOLDING_TAX_AMT,
			OTHER_PROCESS_ID
		FROM 
		Tb_t_Inv_Witholding_Tax')*/
		INSERT INTO TB_T_INV_WITHOLDING_TAX(  
			INV_NO,
			SUPP_INVOICE_NO,
			WITHOLDING_TAX_CD,
			WITHOLDING_TAX_BASE_AMT,
			WITHOLDING_TAX_AMT,
			OTHER_PROCESS_ID,
			PROCESS_ID)
		select DISTINCT ISNULL(INV_NO,''), --1
			   RTRIM(SUPP_INV_NO),  --2
			   RTRIM(WITHHOLDING_TAX_CD), --3
			   BASE_AMT,
			   WITHHOLDING_TAX_AMT,
			   @L_N_PROCESS_ID, --24
			   @L_N_PROCESS_ID
		from TB_R_INV_UPLOAD
		WHERE LTRIM(SUPP_INV_NO)=LTRIM(@SupplierInvoiceNo) AND RTRIM(SUPP_CD)=@SupplierCode AND WITHHOLDING_TAX_CD <> ''
		    
		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @L_N_PROCESS_ID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D
				WHERE PROCESS_ID = @L_N_PROCESS_ID
				)
			,'MPCS00002INF'
			,'INF'
			,'MPCS00002INF : Call SP sending FI journal'
			,@LOCATION
			,@UserID
			,GETDATE()	
		--* FID.Ridwan : 2020-09-22 call invoice creation and posting fi to ics *--
		EXEC [dbo].[SP_INVOICE_SENDING_TO_ICS_FOR_FI_JOURNAL] @UserID ,@L_N_PROCESS_ID ,@SupplierInvoiceNo ,@SupplierCode
			 
	/* Remark FID.Ridwan 2020-09-19
	SELECT  'Tb_t_Inv_Witholding_Tax : ' + RTRIM(CAST(DATEDIFF(MILLISECOND, @st, GETDATE()) AS VARCHAR(MAX))) ' ms'
	SET @st = GETDATE()

		INSERT OPENQUERY (IPPCS_TO_ICS, 
						'SELECT  
							OTHER_PROCESS_ID,
							STATUS,
							REFERENCE,
							CREATED_BY,
							CREATED_DT
						 FROM TB_R_PCS_INTERFACE_STATUS')
		VALUES (@L_N_PROCESS_ID, 0, 'Posting Invoice Payment',@UserID,GETDATE());

	SELECT  'TB_R_PCS_INTERFACE_STATUS : ' + RTRIM(CAST(DATEDIFF(MILLISECOND, @st, GETDATE()) AS VARCHAR(MAX))) ' ms'
	SET @st = GETDATE() */

	END TRY
	BEGIN CATCH
		/*DECLARE @QueryLinkedServer VARCHAR(MAX)
		SET @QueryLinkedServer = 'SELECT SUPP_INVOICE_NO FROM Tb_t_Invoice_h WHERE SUPP_INVOICE_NO=''' + LTRIM(@SupplierInvoiceNo) + ''' AND OTHER_PROCESS_ID=''' + CONVERT(VARCHAR,@L_N_PROCESS_ID) + ''''
		SET @QueryLinkedServer = N'DELETE OPENQUERY(IPPCS_TO_ICS, ''' + REPLACE(@QueryLinkedServer, '''', '''''') + ''')'
		EXEC (@QueryLinkedServer)
		
		SET @QueryLinkedServer = 'SELECT SUPP_INVOICE_NO FROM Tb_t_Invoice_d WHERE SUPP_INVOICE_NO=''' + LTRIM(@SupplierInvoiceNo) + ''' AND OTHER_PROCESS_ID=''' + CONVERT(VARCHAR,@L_N_PROCESS_ID) + ''''
		SET @QueryLinkedServer = N'DELETE OPENQUERY(IPPCS_TO_ICS, ''' + REPLACE(@QueryLinkedServer, '''', '''''') + ''')'
		EXEC (@QueryLinkedServer)
		
		SET @QueryLinkedServer = 'SELECT SUPP_INVOICE_NO FROM Tb_t_Inv_Gl_Account WHERE SUPP_INVOICE_NO=''' + LTRIM(@SupplierInvoiceNo) + ''' AND OTHER_PROCESS_ID=''' + CONVERT(VARCHAR,@L_N_PROCESS_ID) + ''''
		SET @QueryLinkedServer = N'DELETE OPENQUERY(IPPCS_TO_ICS, ''' + REPLACE(@QueryLinkedServer, '''', '''''') + ''')'
		EXEC (@QueryLinkedServer)
		
		SET @QueryLinkedServer = 'SELECT SUPP_INVOICE_NO FROM Tb_t_Inv_Witholding_Tax WHERE SUPP_INVOICE_NO=''' + LTRIM(@SupplierInvoiceNo) + ''' AND OTHER_PROCESS_ID=''' + CONVERT(VARCHAR,@L_N_PROCESS_ID) + ''''
		SET @QueryLinkedServer = N'DELETE OPENQUERY(IPPCS_TO_ICS, ''' + REPLACE(@QueryLinkedServer, '''', '''''') + ''')'
		EXEC (@QueryLinkedServer)
		
		SET @QueryLinkedServer = 'SELECT OTHER_PROCESS_ID FROM TB_R_PCS_INTERFACE_STATUS WHERE OTHER_PROCESS_ID=''' + CONVERT(VARCHAR,@L_N_PROCESS_ID) + ''''
		SET @QueryLinkedServer = N'DELETE OPENQUERY(IPPCS_TO_ICS, ''' + REPLACE(@QueryLinkedServer, '''', '''''') + ''')'
		EXEC (@QueryLinkedServer)*/
		
		--DELETE FROM [TB_R_ICS_QUEUE] WHERE [PROCESS_ID]=@L_N_PROCESS_ID
	END CATCH
END

